C     C final version 7 - separate eigen vectors in separate groups
C     Each group also has its property dataset


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      module hdf_param
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      use HDF5

      INTEGER(HID_T) :: lcrp_list,crp_list,pcrp_list,plist_id ! dataset creatation property identifier
      INTEGER     ::   error          ! Error flag

C     Variables used in HDF5 -Dimensions

      INTEGER(HSIZE_T), DIMENSION(1) :: maxdims, maxdimsw, offset
      INTEGER(HSIZE_T), DIMENSION(1) :: dims, dimsw, dims2, size_ext
      INTEGER(HSIZE_T), DIMENSION(2) :: dims_mem
      INTEGER(SIZE_T) :: dist

      INTEGER(HSIZE_T), DIMENSION(1) :: chunk_dims
      INTEGER :: RANK = 1, rankw = 1

      INTEGER, DIMENSION(1) :: length = (/0/)

CC used if mpiposix is used
      LOGICAL :: flag = 1

      INTEGER(HID_T) :: pdataspace,pdset_id,pfile_id,
     &     pmemspace,pdataspace2,pfile_id2,pdset_id2
      INTEGER(HID_T) :: pfilespace,ldset_id,ldataspace
      INTEGER(HID_T) :: pgrpid,pgrp_id2,pgrp_id
      CHARACTER(LEN=25) :: pdsetname,pdsetname2
      CHARACTER(LEN=25) :: ldsetname = "LENGTHS"
      CHARACTER(LEN=12) :: pfilename = "mfdn.smwf001"
      CHARACTER(LEN=12) :: pfilename2 = "hdfopfile"
      CHARACTER(LEN=12) :: smwfname
      CHARACTER(LEN=12) :: pgrpname,pgrpname2
      CHARACTER(LEN=2) :: dsetno


      integer parallelOffset,ilengplus,ilengtemp,dim,i1reach_root
      INTEGER,ALLOCATABLE,DIMENSION(:) :: lenArray
      INTEGER(HID_T) :: type_id,dtype_id
      INTEGER(HID_T) :: dt1_id,dt2_id,dt3_id,dt4_id,dt5_id

      real*8 start, end, endall,readsum,writesum
      real temp1, temp2
      INTEGER(SIZE_T) :: typesize,type_sizei,type_sizer,type_size


      ! MPI definitions and calls.
      !
      INTEGER :: mpierror       ! MPI error flag
      INTEGER :: comm, info
      INTEGER :: mpi_size, mpi_rank
      end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      subroutine phdfread(pfile,pgroupname,pdatasetname,
     &     pdataarray,pdatalength,poffset,ierr)
C
      use hdf_param


      integer pdatalength,poffset
      INTEGER     ::   ierr    ! Error flag
      real*4,dimension(pdatalength) :: pdataarray
      character(len=25) pdatasetname
      INTEGER(HID_T) :: pdsetid,pdspaceid
      CHARACTER(LEN=12) :: pgroupname
      CHARACTER(LEN=12) :: pfile
      INTEGER(HID_T) :: pgroupid


      CALL h5open_f(error)

      CALL h5pcreate_f(H5P_FILE_ACCESS_F,pcrp_list,error)


      CALL h5pset_fapl_mpio_f(pcrp_list,comm,info,error)

c     OPEN the file.

      CALL h5fopen_f(pfile,H5F_ACC_RDONLY_F,pfile_id,
     &     error,pcrp_list)
      if (error.ne.0) then
         write(*,*) 'File open failed'
      endif


      CALL h5pclose_f(pcrp_list,error)
      CALL h5gopen_f(pfile_id,pgroupname,pgroupid, error)

CCCC  Open the  dataset
      CALL h5dopen_f(pgroupid,pdatasetname,pdsetid, error)
      if (error.ne.0) then
         write(*,*) 'dataset open failed in phdfread'
      endif

C     Get dataset's dataspace handle.

      CALL h5dget_space_f(pdsetid,pdspaceid,error)


C     Get dataset's dataspace handle.

C      CALL h5dget_space_f(pdsetid,pdspaceid,error)

      offset(1) = poffset
      dims2(1) = pdatalength

C     SELECT HYPERSLAB according to the offsets supplied

      CALL h5sselect_hyperslab_f(pdspaceid,
     &     H5S_SELECT_SET_F,offset,dims2,error)

C     Create memory dataspace the same size as the hyperslab selected
      CALL h5screate_simple_f(rank,dims2,pmemspace,error)

C     Create property list for collective dataset write
      CALL h5pcreate_f(H5P_DATASET_XFER_F,pcrp_list,error) 
      CALL h5pset_dxpl_mpio_f(pcrp_list,H5FD_MPIO_INDEPENDENT_F,error)

C     Get the datatype of the data in the dataset
      CALL h5dget_type_f(pdsetid,type_id,error)

C     READ the dataset collectively.
      CALL h5dread_f(pdsetid,type_id,pdataarray,dims2,error,
     &     file_space_id = pdspaceid,mem_space_id = pmemspace,
     &     xfer_prp = pcrp_list)
      ierr = error




      CALL h5sclose_f(pmemspace, error)
      CALL h5sclose_f(pdspaceid, error)
      CALL h5dclose_f(pdsetid,error)
      CALL h5pclose_f(pcrp_list, error)
      CALL h5gclose_f(pgroupid,error)
      CALL h5fclose_f(pfile_id,error)
      CALL h5tclose_f(type_id,error)
      CALL h5close_f(error)

      return

      end subroutine phdfread
c


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      subroutine phdfwrite(pfile,pgroupname,pdatasetname,
     &     pdataarray,pdatalength,poffset,ierr)
C
      use hdf_param


      integer pdatalength,poffset
      INTEGER     ::   ierr     ! Error flag
      real*4,dimension(pdatalength) :: pdataarray
      character(len=25) pdatasetname
      INTEGER(HID_T) :: pdsetid,pdspaceid
      CHARACTER(LEN=12) :: pgroupname
      CHARACTER(LEN=12) :: pfile
      INTEGER(HID_T) :: pgroupid

C     Initialize the fortran interface for HDF5
      CALL h5open_f(error)

      CALL h5pcreate_f(H5P_FILE_ACCESS_F,pcrp_list,error)

      CALL h5pset_fapl_mpio_f(pcrp_list,comm,info,error)

c     OPEN the file.

      CALL h5fopen_f(pfile,H5F_ACC_RDWR_F,pfile_id,
     &     error,pcrp_list)
      if (error.ne.0) then
         write(*,*) 'File open failed'
      endif

      CALL h5pclose_f(pcrp_list,error)
      CALL h5gopen_f(pfile_id,pgroupname,pgroupid, error)

CCCC  Open the  dataset
      CALL h5dopen_f(pgroupid,pdatasetname,pdsetid, error)
      if (error.ne.0) then
         write(*,*) 'dataset open failed in phdfwrite'
      endif

C     Get dataset's dataspace handle.

      CALL h5dget_space_f(pdsetid,pdspaceid,error)

C     Get dataspace's rank.
      CALL h5sget_simple_extent_dims_f(pdspaceid,
     &     dimsw, maxdimsw, error)

      offset(1) = poffset

      dims2(1) = pdatalength
      CALL h5dget_type_f(pdsetid,type_id,error)

C     Select hyperslab for the data to be written.
      CALL h5sselect_hyperslab_f(pdspaceid,
     &     H5S_SELECT_SET_F,offset,dims2,error)

C     create memory dataspace of the same rank and dims as
C     the file dataspace selected above.

      CALL h5screate_simple_f(rank,dims2,pmemspace,error)

C     Create property list for collective dataset write, 

      CALL h5pcreate_f(H5P_DATASET_XFER_F,pcrp_list,error) 
      
C      CALL h5pset_dxpl_mpio_f(pcrp_list,H5FD_MPIO_COLLECTIVE_F,error)
         
      CALL h5pset_dxpl_mpio_f(pcrp_list,H5FD_MPIO_INDEPENDENT_F,
     &     error)
           
C     Write the dataset
      CALL h5dwrite_f(pdsetid,type_id,pdataarray,dims2,error,
     &     file_space_id = pdspaceid, mem_space_id = pmemspace,
     &     xfer_prp = pcrp_list)
      CALL h5fflush_f(pfile_id,H5F_SCOPE_GLOBAL_F,error)

      CALL h5sclose_f(pmemspace, error)
      CALL h5sclose_f(pdspaceid, error)
      CALL h5dclose_f(pdsetid,error)
      CALL h5pclose_f(pcrp_list, error)
      CALL h5gclose_f(pgroupid,error)
      CALL h5fclose_f(pfile_id,error)
      CALL h5close_f(error)
      return

      end subroutine phdfwrite
c
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
